TITLE   BEEP.ASM a beep program for the HP-95LX
SUBTTL  From the "HP-95 Utility Pack"
; (C) 1991 Richard E. Harvey, P.O. Box 5695 Glendale, AZ 85312
; You may distribute programs created from this source code but you cannot
; distribute this source code without the express written permission of
; the author.
; Assemble with Microsoft MASM 6.0 or later or Borland TASM.
; Last edited: June 8, 1991
Duration = 3                            ; number of clock ticks per beep
_TEXT   SEGMENT WORD PUBLIC 'CODE'
        ASSUME CS:_TEXT, DS:_TEXT, SS:_TEXT, ES:NOTHING
        ORG 100h
Start:
        ; The values in <> are frequencies. You can add or delete notes or
        ; change frequencies from 37 through around 8000.
        IRP     Freq, <660, 440, 880, 660>
         mov    bx, 1193182 / Freq
         call   near ptr Beep
        ENDM

        mov     ax, 4c00h               ; Terminate with return code
        int     21h

Beep:                                   ; Entry: BX=1193182Hz / Freq
        mov     al, 0b6h                ; initialize the timer
        out     43h, al

        xchg    ax, bx                  ; get the frequency to AX
        out     42h, al                 ; write the first byte
        mov     al, ah
        out     42h, al                 ; and the second byte
        in      al, 61h
        or      al, 3
        out     61h, al                 ; we're beeping

        xor     ax, ax                  ; point ES at BIOS memory
        mov     es, ax                  ; (we're in no hurry here)
        mov     ax, es:[046ch]          ; get the current time
        add     ax, Duration            ; the exit value
Pause:  cmp     ax, Word Ptr es:[046ch] ; check the current time
        ja      Pause                   ; if Duration ticks haven't passed

        in      al, 61h                 ; turn off the speaker
        xor     al, 3
        out     61h, al
        ret

        DB 13,10,"(C)91 Richard E.Harvey"
_TEXT   ENDS
END     Start
